﻿#include "Track2D.h"


Track2D::Track2D():BaseTrack(8, 4)
{
    std::shared_ptr<mytracker::KalmanFilter> kf = std::make_shared<mytracker::KalmanFilter>(8, 4);
    kf->F_ <<
        1, 0, 0, 0, 1, 0, 0, 0,
        0, 1, 0, 0, 0, 1, 0, 0,
        0, 0, 1, 0, 0, 0, 1, 0,
        0, 0, 0, 1, 0, 0, 0, 1,
        0, 0, 0, 0, 1, 0, 0, 0,
        0, 0, 0, 0, 0, 1, 0, 0,
        0, 0, 0, 0, 0, 0, 1, 0,
        0, 0, 0, 0, 0, 0, 0, 1;
    kf->P_ <<
        10, 0, 0, 0, 0, 0, 0, 0,
        0, 10, 0, 0, 0, 0, 0, 0,
        0, 0, 10, 0, 0, 0, 0, 0,
        0, 0, 0, 10, 0, 0, 0, 0,
        0, 0, 0, 0, 10000, 0, 0, 0,
        0, 0, 0, 0, 0, 10000, 0, 0,
        0, 0, 0, 0, 0, 0, 10000, 0,
        0, 0, 0, 0, 0, 0, 0, 10000;
    kf->H_ <<
        1, 0, 0, 0, 0, 0, 0, 0,
        0, 1, 0, 0, 0, 0, 0, 0,
        0, 0, 1, 0, 0, 0, 0, 0,
        0, 0, 0, 1, 0, 0, 0, 0;
    kf->Q_ <<
        1, 0, 0, 0, 0, 0, 0, 0,
        0, 1, 0, 0, 0, 0, 0, 0,
        0, 0, 1, 0, 0, 0, 0, 0,
        0, 0, 0, 1, 0, 0, 0, 0,
        0, 0, 0, 0, 0.01, 0, 0, 0,
        0, 0, 0, 0, 0, 0.01, 0, 0,
        0, 0, 0, 0, 0, 0, 0.0001, 0,
        0, 0, 0, 0, 0, 0, 0, 0.0001;
    kf->R_ <<
        1, 0, 0, 0,
        0, 1, 0, 0,
        0, 0, 10, 0,
        0, 0, 0, 10;

    kf_ = kf;
}


double Track2D::CalculateIou(const std::vector<float>& data)
{
    std::vector<float> states;
    GetStateData(states);

    //auto xx1 = std::max(states[0], data[0]);
    //auto yy1 = std::max(states[1], data[1]);
    //auto xx2 = std::min(det.br().x, trk.br().x);
    //auto yy2 = std::min(det.br().y, trk.br().y);
    //auto w = std::max(0, xx2 - xx1);
    //auto h = std::max(0, yy2 - yy1);

    //// calculate area of intersection and union
    //float det_area = det.area();
    //float trk_area = trk.area();
    //auto intersection_area = w * h;
    //float union_area = det_area + trk_area - intersection_area;
    //auto iou = intersection_area / union_area;

    auto w = std::max(std::min((states[0] + states[2]), (data[0] + data[2])) - std::max(states[0], data[0]), 0.0f);
    auto h = std::max(std::min((states[1] + states[3]), (data[1] + data[3])) - std::max(states[1], data[1]), 0.0f);

    auto intersection_area = w * h;
    float union_area = states[2] * states[3] + data[2] * data[3] - intersection_area;
    auto iou = intersection_area / union_area;
	return iou;
}
