#ifndef COMMON_H
#define COMMON_H

// headers in STL
#include <stdio.h>

// headers in CUDA
//#include <cuda_runtime_api.h>


#define DIVUP(m, n) ((m) / (n) + ((m) % (n) > 0))

#define GPU_CHECK(ans)                                                                                                 \
  {                                                                                                                    \
    GPUAssert((ans), __FILE__, __LINE__);                                                                              \
  }
inline void GPUAssert(cudaError_t code, const char* file, int line, bool abort = true)
{
  if (code != cudaSuccess)
  {
    fprintf(stderr, "GPUassert: %s %s %d\n", cudaGetErrorString(code), file, line);
    if (abort)
      exit(code);
  }
}

//Memory Allocation Function
//void cpuMalloc(float **data_ptr, size_t size)
//{
//	float *data;
//	data = (float *) malloc( size);
//	*data_ptr = data;
//}


//Ideintity Matrix Generation
//void Identity(float *data, int n)
//{
//        for (int i = 0; i < (n*n); i=i+1)
//                {
//                if((i%(n+1))==0)
//                        data[i] = 1;
//                else
//                        data[i] = 0;
//                }
//}



#endif  // COMMON_H
