﻿
#include "Component.h"
#include <sys/time.h>
#include <unistd.h>

uint64_t GetCurTime()
{
    struct timeval time;
    gettimeofday(&time, NULL);
    uint64_t seconds = time.tv_sec;
    uint64_t ttt = seconds * 1000 * 1000 + time.tv_usec;
    return ttt;
}

std::string GetMatrixStr(const float* data_ptr, int col, int row)
{
    std::string str;
    for (int i = 0; i < row; i++)
    {
        for (int j = 0; j < col; j++)
        {
            char log[128] = {};
            sprintf(log, "%f,", data_ptr[i*col+j]);
            str += log;
        }
    }
    return str;
}

std::string GetMatrixStr(const std::vector<std::vector<float>>& data_ptr, int col, int row)
{
    std::string str;
    for (int i = 0; i < col; i++)
    {
        for (int j = 0; j < row; j++)
        {
            char log[128] = {};
            sprintf(log, "%f,", data_ptr[i][j]);
            str += log;
        }
    }
    return str;
}
std::string GetMatrixStr(const std::vector<std::vector<double>>& data_ptr, int col, int row)
{
    std::string str;
    for (int i = 0; i < col; i++)
    {
        for (int j = 0; j < row; j++)
        {
            char log[128] = {};
            sprintf(log, "%f,", data_ptr[i][j]);
            str += log;
        }
    }
    return str;
}

std::string GetMatrixStr(float** data_ptr, int col, int row)
{
    std::string str;
    for (int i = 0; i < row; i++)
    {
        for (int j = 0; j < col; j++)
        {
            char log[128] = {};
            sprintf(log, "%f,", data_ptr[i][j]);
            str += log;
        }
    }
    return str;
}


std::string GetTimeStr(uint64_t timestamp)
{
    time_t tt = timestamp / 1000;
    int misc = timestamp % 1000;
    struct tm* ptr;
    ptr = localtime(&tt);
    // printf("time: %d \n", tt);
    char str[80];
    strftime(str, sizeof(str), "%Y-%m-%d %H:%M:%S", ptr);
    //2018-09-19 16:01:37.517
    char tStr[128] = {};
    sprintf(tStr, ".%d", misc);
    std::string timeStr = std::string(str) + std::string(tStr);
    return timeStr;
}

double calcIntersectionArea(cv::RotatedRect rect1, cv::RotatedRect rect2)
{
    std::vector<cv::Point2f> vertices;
    int intersectionType = cv::rotatedRectangleIntersection(rect1, rect2, vertices);
    if (vertices.size() == 0)
        return 0.0;
    else
    {
        std::vector<cv::Point2f> order_pts;
        // 找到交集（交集的区域），对轮廓的各个点进行排序

        cv::convexHull(cv::Mat(vertices), order_pts, true);
        double area = cv::contourArea(order_pts);
        //float inner = (float)(area / (areaRect1 + areaRect2 - area + 0.0001));
        return area;
    }
}

float calcIntersectionRate(cv::RotatedRect rect1, cv::RotatedRect rect2)
{
    double area = calcIntersectionArea(rect1, rect2);

    float iou_2d = area / (rect1.size.width * rect1.size.height + rect2.size.width * rect2.size.height);
    return iou_2d;
}
