#include <ros/ros.h>
#include <ros/package.h>
#include "imageAsyncSubscriber.h"
#include <yaml-cpp/yaml.h>
#include <stdio.h>
#include "vision_config.h"

using namespace jfx_vision;

std::unique_ptr<VisionConfig>  jfx_vision::g_visionConfig;

int main(int argc, char*argv[]) {
    ROS_INFO("START JFX_VISION_NODE");
    ros::init(argc, argv, "jfx_vision");
    ros::NodeHandle nh("~");

    string pkgName = "jfx_rvconfig";
    string pkgPath = ros::package::getPath(pkgName);

    std::string config_yaml = pkgPath + "/param/vision_config.yaml";
    nh.param<std::string>("vision_config_path", config_yaml, pkgPath + "/param/vision_config.yaml");

    ROS_INFO("use config file: %s", config_yaml.c_str());

    g_visionConfig.reset(new VisionConfig(config_yaml));

    int cam_size = g_visionConfig->globalConf.camera_size;
    ROS_INFO("cam_size:%d", cam_size);

    ImageAsyncSubscriber<sensor_msgs::Image> sync(nh, cam_size); 
    
    ros::spin();

    return 0;
}
