#coding:utf-8

import sys
import math
#sys.path.append("./venv/Lib")
import gaussian
import numpy as np

def wgs84_angle_cal(lat1,lon1,lat2,lon2):
	p1 = np.array([lat1, lon1])
	p11 = gaussian.Convert_v2(p1)
	#print(gaussian.Convert_v2(p1))

	p2 = np.array([lat2, lon2])
	p22 = gaussian.Convert_v2(p2)
	#print(gaussian.Convert_v2(p2))

	x = abs(p22[0] - p11[0])
	y = abs(p22[1] - p11[1])

	#print(math.sqrt(x * x + y * y))
	tmp_angle = math.atan(y / x) * 57.29578

	#print(tmp_angle)

	if p22[0] > p11[0] and p22[1] > p11[1]:
		angle = 90 - tmp_angle
	elif p22[0] > p11[0] and p22[1] < p11[1]:
		angle = 90 + tmp_angle
	elif p22[0] < p11[0] and p22[1] > p11[1]:
		angle = 270 + tmp_angle
	elif p22[0] < p11[0] and p22[1] < p11[1]:
		angle = 270 - tmp_angle
	elif p22[0] == p11[0] and p22[1] < p11[1]:
		angle = 180
	elif p22[0] < p11[0] and p22[1] == p11[1]:
		angle = 270
	elif p22[0] > p11[0] and p22[1] == p11[1]:
		angle = 90
	else:
		angle = 0
	return angle

def xy_angle_cal(x1,y1,x2,y2):

	x = abs(x2 - x1)
	y = abs(y2 - y1)

	#print(math.sqrt(x * x + y * y))
	tmp_angle = math.atan(y / x) * 57.29578

	#print(tmp_angle)

	if x2 > x1 and y2 > y1:
		angle = 90 - tmp_angle
	elif x2 > x1 and y2 < y1:
		angle = 90 + tmp_angle
	elif x2 < x1 and y2 > y1:
		angle = 270 + tmp_angle
	elif x2 < x1 and y2 < y1:
		angle = 270 - tmp_angle
	elif x2 == x1 and y2 < y1:
		angle = 180
	elif x2 < x1 and y2 == y1:
		angle = 270
	elif x2 > x1 and y2 == y1:
		angle = 90
	else:
		angle = 0
	return angle

def car_yaw_cal(base_angle,car_yaw):
    tmp_angle = 0.0
    car_angle = car_yaw / math.pi * 180.0
    if car_angle >= 0:
	tmp_angle = base_angle - car_angle
    else:
	tmp_angle = base_angle + abs(car_angle)

    return (tmp_angle+360.0)%360.0

def compute_yaw(car_yaw_in_lidar):
    '''
  lat1 = 31.2808039
  lon1 = 121.1876594
  p1 = np.array([lat1, lon1])
  p11 = gaussian.Convert_v2(p1)

  lidar_x = p11[0]
  lidar_y = p11[1]

  R = [[6.61568761e-01, -7.49847829e-01,  7.42486399e-03], 
       [7.49874949e-01,  6.61577821e-01, -1.51043758e-03],
	[-3.77952680e-03,  6.56697899e-03,  9.99971211e-01]]

    #取x轴两个点坐标用来标定lidar的x轴的绝对航向
  tmp_loc1 = [30,0,0]
  tmp_loc2 = [50,0,0]

  tmp_xyz1 = np.dot(R,tmp_loc1)
  tmp_xyz2 = np.dot(R, tmp_loc2)
    '''
    #计算lidar x轴的绝对航向
    #lidar_x_angle = (xy_angle_cal(tmp_xyz1[0],tmp_xyz1[1],tmp_xyz2[0],tmp_xyz2[1]) + 90.0)%360.0
    lidar_x_angle = 88.35201485622395

    #print("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ the lidar_x_angle is:",lidar_x_angle)
    #将局部坐标系的航向，转换成绝对航向
    yaw = car_yaw_cal(lidar_x_angle,car_yaw_in_lidar)
    #print("the car yaw is:",yaw)
    return yaw

if __name__ == "__main__":
    lat1 = 31.2840452
    lon1 = 121.1597165
    p1 = np.array([lat1, lon1])
    p11 = gaussian.Convert_v2(p1)

    lidar_x = p11[0]
    lidar_y = p11[1]

    R = [[-0.330806583166,  -0.941249847412,  0.067936882377], 
       [0.943696200848,  -0.329787790775,  0.026026830077],
	[-0.002092991956,  0.072721630335,  0.997349977493]]

    #取x轴两个点坐标用来标定lidar的x轴的绝对航向
    tmp_loc1 = [30,0,0]
    tmp_loc2 = [50,0,0]

    tmp_xyz1 = np.dot(R,tmp_loc1)
    tmp_xyz2 = np.dot(R, tmp_loc2)
    #计算lidar x轴的绝对航向
    lidar_x_angle = (xy_angle_cal(tmp_xyz1[0],tmp_xyz1[1],tmp_xyz2[0],tmp_xyz2[1]) + 90.0)%360.0
    print(lidar_x_angle)
