#include <iostream>
#include <sstream>
#include <string>
#include <thread>
#include <vector>
#include <sys/time.h>
#include "unistd.h"

#include "modules/yolov5.hpp"
#include "modules/config.hpp"

int main(int argc, char** argv) {

    YoloV5 yolo;
    yolo.Init("/home/nvidia/whl/yolov5/build/yolov5sfp16_0724_608_3.engine",3);
    std::vector<cv::Mat> imgs;
    cv::Mat mat0 = cv::imread("/home/nvidia/whl/1.png");
    for(int i = 0; i < 3;i++){
        auto tmp = mat0.clone();
        imgs.push_back(tmp);
    }
    yolo.preprocess(imgs);
    yolo.infer();
    yolo.post();
    auto results = yolo.GetResults();
    for(int m = 0; m < (int)results.size();m++){
        cv::Mat out = imgs[m];
        for(auto re : results[m]->results){
            std::stringstream ss;
            ss << round(re.prob * 1000) / 1000.0;
            std::string str = std::to_string(re.num_class) + ":" + ss.str();
            cv::Point p5(re.location[0], re.location[1] + 10);
            cv::putText(out, str, p5, cv::FONT_HERSHEY_SIMPLEX, 0.8,
                    cv::Scalar(0, 0, 255), 0.5);
            cv::Rect r(re.location[0], re.location[1],re.location[2]-re.location[0], re.location[3]-re.location[1]); 
            cv::rectangle(out, r, cv::Scalar(0x27, 0xC1, 0x36), 2);
        }
        std::string name = std::to_string(m) + ".jpg";
        cv::imwrite(name,out);
    }
}
